// The following code was lifted from Apple.com ... it is copyright (c) Apple Computer 2006.

function addEventToObject(obj, evt, func) {
	var oldhandler = obj[evt];
	obj[evt] = (typeof obj[evt] != 'function') ? func : function(){oldhandler();func();};
}

function intComma(num) {
    var T = "", S = String(num), L = S.length - 1, C, j, P = S.indexOf(".") - 1;
    if (P < 0) {P = L;}
    for (j = 0; j <= L; j++) {
        T += (C = S.charAt(j));
        if ((j < P) && ((P - j) % 3 == 0) && (C != "-")) {T += ",";}
    }
    return T;
}

function ajaxRequest(url,func) {
    if (window.XMLHttpRequest) {
        var req = new XMLHttpRequest();
        if (func) {req.onreadystatechange = function() {func(req);}}
        req.open("GET", url, true);
//        if (browser.isSafari) {req.setRequestHeader('If-Modified-Since','Wed, 15 Nov 1995 00:00:00 GMT');}
        req.setRequestHeader('If-Modified-Since','Wed, 15 Nov 1995 00:00:00 GMT');
        req.send(null);
    } else if (window.ActiveXObject) {
        isIE = true;
		try {var req = new ActiveXObject("Msxml2.XMLHTTP");}
		catch(e) {req = new ActiveXObject("Microsoft.XMLHTTP");}
        if (req) {
            if (func) {req.onreadystatechange = function() {func(req);}}
            req.open("GET", url, true);
            req.send();
        }
    }
}

//initialize vars
var c, ci, initDate, curDate, curDateElapsed, curCountElapsed, preDate, dateDiff, timeoutID;
var initCount = curCount = preCount = addCount = tempCount = countDiff = rate = 0;
var XMLHttpRequests = 0; // DEBUG
var update = 5 //in mins
var incr = 100 //in msecs
var refresh = 60000 //in msecs, should be 1 min (60000 ms)
var safariBugFixCounter = null;
var countTimer = null; //pledit

function initializeProcessReqChange(req) {
	if (req.readyState == 4) {
		if (req.status == 200) {
			setCounters(req);
			if (XMLHttpRequests < 1 || !countTimer) runCountdown(); //pledit
			XMLHttpRequests+=1;/*DEBUG*/
		} else {
			//alert("There was a problem retrieving the XML data:\n" + req.statusText); //pledit
			clearTimeout(countTimer); //pledit
			countTimer = null; //pledit
		}
	}
	document.body.style.cursor = 'default';
	return true;
}

function setCounters(req) {	
	preCount = parseInt(req.responseXML.getElementsByTagName('count')[1].childNodes[0].nodeValue);
	//if new values
	if (preCount == initCount || initCount == 0) {
		initCount = parseInt(req.responseXML.getElementsByTagName('count')[0].childNodes[0].nodeValue);
		initDate = new Date(req.responseXML.getElementsByTagName('count')[0].getAttribute('timestamp'));
		preDate = new Date(req.responseXML.getElementsByTagName('count')[1].getAttribute('timestamp'));
		//calculate difference in values
		countDiff = initCount-preCount;
		//calculate difference in time of values
		dateDiff = parseInt(initDate.valueOf()-preDate.valueOf());
		//calculate rate of increase ((songs downloaded in previous time)/time)*incr
		rate = countDiff/dateDiff;
		rate = rate*0.8; //pledit
		//calculate number of songs to add each loop
		//calculate current time
		curDate = new Date();
		//calculate time since last update
		curDateElapsed = curDate.valueOf() - initDate.valueOf();
		//calculate projected number of songs since last update
		curCountElapsed = curDateElapsed*rate;
		
		//add projected number of songs to most recent value
		curCount = initCount+curCountElapsed;
	}
}

function runCountdown() {
		
		//increase value of counter at constant increment
		//calculate number of songs to increase per increment
		//multiply rate by increment
		addCount = rate*incr;
		
		//add this number to counter
		curCount += addCount;
		//update document content
		//set counter to predicted count
		
		c.innerHTML = (curCount<1000000000) ? intComma(Math.floor(curCount)) : "1,000,000,000+";
//		if (ci) {ci.innerHTML = (curCount<1000000000) ? intComma(Math.floor(curCount)) : "1,000,000,000+";}
		//alert('run at '+incr);
		document.getElementById('thismustbehere').value = curCount;
		// getting called from blocks.js
		countTimer = setTimeout(runCountdown, incr); //pledit
}

function doCountdown() {	
		//get most recent values from xml and process
		// generating a random param to uncache the file
		var rNum = Math.random() * 100000;
		ajaxRequest('http://www.apple.com/itms_counter.xml?r='+rNum,initializeProcessReqChange);
		//on one minute loop, getting called from blocks.js
		//var refreshTimer = setTimeout(doCountdown,refresh);
}
//on page load 
function initCountdown() {
	// do widget initialization stuff first
	createGenericButton(document.getElementById("doneButton"), "Done", null);
	
	//create reference to counter object
	c = document.getElementById('countdown');
//	ci = (document.getElementById('countdown2')) ? document.getElementById('countdown2') : null;
	//do countdown
/*	if ((browser.isIE == true) && (browser.isMac == true)) {
		var counterDiv = (document.getElementById('counter')) ? document.getElementById('counter') : null;
		//Put any chunk of HTML in here you wish to be displayed for IE Mac
		var ieMacContent = '<img src="http://images.apple.com/itunes/1billion/images/counterbg.gif" alt="" width="180" height="77" id="top_img">';
		counterDiv.innerHTML = ieMacContent;
	} else {*/
		doCountdown();
//	}
}
addEventToObject(window,'onload',initCountdown);
